 //The following program is an implementation of a Sudoku Solver in C.
//Sudoku is a 9*9 grid in which each row,each column and each 3*3 grid contains all numbers from 1 to 9 only once.
//The program uses backtracking approach to solve the sudoku. There is a recursive function to solve the sudoku.

#include<iostream>
#include<fstream>

using namespace std;
int sudoku[9][9]={0};//The array which stores entries for the sudoku
int temp[9][9]={0};
int ar[9][9]={0};
int check=1;
void solvesudoku(int,int);

int check_sudoku_row(int row)
{
 int i;
 int column,count=0,flag=1;
 for(i=1;i<=9;i++)
 {   count=0;
     for(column=0;column<9;column++)
     {
         if(sudoku[row][column]==i)
         {
             count++;
             if(count>=2)
             {
                 flag=0;
                 break;
             }
         }
     }
     if(flag==0)
        break;
 }
  return flag;

}
int check_sudoku_column(int column)
{
 int row,count=0,flag=1;
 int i;
 for(i=1;i<=9;i++)
 {   count=0;
     for(row=0;row<9;row++)
     {
         if(sudoku[row][column]==i)
         {
             count++;
             if(count>=2)
             {
                 flag=0;
                 break;
             }
         }
     }
     if(flag==0)
        break;
 }
  return flag;

}

int check_sudoku_grid(int row,int column)
{
 int count=0,flag=1;
 int i;
 row=(row/3)*3;
 column=(column/3)*3;
 int r,c;
 for(i=1;i<=9;i++)
 {
    count=0;
    for(r=0;r<3;r++)
    {
        for(c=0;c<3;c++)
        {
          if(sudoku[row+r][column+c]==i)
          {
              count++;
              if(count>=2)
              {
                 flag=0;
                 break;
              }
          }

        }
    if(flag=0)
    break;
    }
    if(flag=0)
        break;
 }
  return flag;

}
void user_Solve_Sudoku()
{ int ch;
    while(1)
    {
    cout<<"Press 1 to enter a value in the unsolved sudoku \nPress 2 to get the solution of the sudoku\n";

    cin>>ch;
    int row,column;
    if(ch==1)
    {
            cout<<"Enter row number and column number at which you wish to make an entry\n";
            scanf("%d %d",&row,&column);
            if(sudoku[row-1][column-1]!=0)
                {
                cout<<"Cannot alter the entry at "<<row<<column<<endl;
                user_Solve_Sudoku();
                }
                cout<<"Enter element to enter\n";
                cin>>temp[row-1][column-1];
            for(row=0;row<9;row++)
           {
            for(column=0;column<9;column++)
            cout<<temp[row][column]<<" | ";
            cout<<"\n\n";
           }
    check=0;
    }
    else if(ch==2)
    {

        return;
    }
    }
}
int checkrow(int row,int num)
{/*This function checks whether we can put the number(num) in the row(row) of the Sudoku or not*/
int column;
for(column=0;column<9;column++)
    if(sudoku[row][column]==num)
        return 0 ;/*If the number is found already present at certain location we return zero*/
return 1;/*If the number is not found anywhere we return 1*/
}
int checkcolumn(int column,int num)
{/*This function checks whether we can put the number(num) in the column(column) of the Sudoku or not*/
int row;
for(row=0;row<9;row++)
    if(sudoku[row][column]==num)
        return 0;/*If the number is found already present at certain location we return zero*/
return 1;/*If the number is not found anywhere we return 1*/
}
int checkgrid(int row,int column,int num)
{/*This function checks whether we can put the number(num) in the 3*3 grid or not
//We get the starting row and column for the 3*3 grid*/
row=(row/3)*3 ;
column=(column/3)*3;
int r,c;
for(r=0;r<3;r++)
    for(c=0;c<3;c++)
         if(sudoku[row+r][column+c]==num)
            return 0;/*If the number is found already present at certain location we return zero*/
return 1;/*If the number is not found anywhere we return 1*/
}
void navigate(int row,int column)
{/*Function to move to the next cell in case we have filled one cell*/
if(column<8)
        solvesudoku(row,column+1);
    else
       solvesudoku(row+1,0);
}
void display()
{/*The function to display the solved Sudoku*/
int row,column;
cout<<"\nTHE SOLVED SUDOKU \n\n";
for(row=0;row<9;row++)
{
for(column=0;column<9;column++){
ar[row][column]=sudoku[row][column];
cout<<sudoku[row][column]<<" | ";}
cout<<"\n\n";
}

}
void solvesudoku(int row,int column)
{
    if(row>8)/*If the row number is greater than 8 than we have filled all cells hence we have solved the sudoku*/
    display();
    if(sudoku[row][column]!=0)
    navigate(row,column);/*If the value filled at a cell is not zero than it is filled with some value from 0 to 9 hence we move further*/
    else
    {
        int ctr;/*This is a counter to check numbers from 1 to 9 whether the number can be filled in the cell or not*/
        for(ctr=1;ctr<=9;ctr++)
        {/*We check row,column and the grid*/
        if((checkrow(row,ctr)==1)&&(checkcolumn(column,ctr)==1)&&(checkgrid(row,column,ctr)==1))
        {
            sudoku[row][column]=ctr;
             navigate(row,column);
        }
        }
        sudoku[row][column]=0;/*No valid number was found so we clean up and return to the caller.*/
    }

}
int main()
{
    int row,column,choice;
    int level;
    int flag=1;
    char ch;
    int arr[81];
    FILE *file;
    cout<<"!!!!!!!!!!!!WELCOME TO THE GAME!!!!!!!!!!\n\n";
    cout<<"##########    SUDOKU: THE MIND GAME    ############\n\n";
    cout<<"YOU HAVE TWO CHOICES EITHER YOU ENTER YOUR OWN INCOMPLETE SUDOKU OR ASK THE PROGRAM TO GENERATE THE SAME ";

    cout<<"\nPRESS 1 TO ENTER YOUR OWN INCOMPLETE SUDOKU ";
    cout<<"\nPRESS 2 TO ASK PROGRAM TO GENERATE AN INCOMPLETE SUDOKU\n";
    cin>>choice;

    switch(choice)
    {
        case 1:{    int c=1;

                    cout<<"\nEnter the desired sudoku and enter 0 for unknown entries\n";
                    for(row=0;row<9;row++)
                    for(column=0;column<9;column++)
                    cin>>sudoku[row][column];

                    for(row=0;row<9;row++)
                    {
                        for(column=0;column<9;column++)
                        {
                            if(check_sudoku_row(row)==0 || check_sudoku_column(column)==0 || check_sudoku_grid(row,column==0))
                            {   flag=0;
                                cout<<"The Sudoku entered is incorrect\n";

                                return 0;
                            }
                        }
                        if(flag==0)
                            break;
                    }
                    break;
               }
        case 2:{
                   cout<<"\nplease enter the difficulty level\n";
                   cout<<"press 1 : EASY\npress 2: MEDIUM\npress 3: DIFFICULT\n\n";
                   cin>>level;
                   switch(level)
                            {
                                case 1: {
                                            file=fopen("sudoku1.txt","r");
                                            for (row = 0; row < 9; row++) {
                                            for (column = 0; column < 9; column++) {
                                            ch=fgetc(file);
                                            sudoku[row][column]=ch-48;}}
                                            fclose(file);
                                            break;
                                            }
                               case 2: {
                                            file=fopen("sudoku2.txt","r");
                                            for (row = 0; row < 9; row++) {
                                            for (column = 0; column < 9; column++) {
                                            ch=fgetc(file);
                                            sudoku[row][column]=ch-48;}}
                                            fclose(file);
                                            break;
                                         }
                                 case 3:{
                                            file=fopen("sudoku3.txt","r");
                                            for (row = 0; row < 9; row++) {
                                            for (column = 0; column < 9; column++) {
                                            ch=fgetc(file);
                                            sudoku[row][column]=ch-48;}}
                                            fclose(file);
                                            break;
                                        }

                             }
          }
    }
cout<<"THE INCOMPLETE SUDOKU :-\n\n";
int count=0;
for(row=0;row<9;row++)
    {
        for(column=0;column<9;column++)
    {
        cout<<sudoku[row][column]<<" | ";
        temp[row][column]=sudoku[row][column];

    }
cout<<"\n\n";
}
user_Solve_Sudoku();
solvesudoku(0,0);
cout<<"\n";

if(check==0){
int d=1;
    for(row=0;row<9;row++)
    {
    for(column=0;column<9;column++)
        {
        if((temp[row][column]!=ar[row][column])&&(temp[row][column]==0))
        {d=0;
         break;
        }
    if(d==0)
    break;
    }
    }
        if(d==0)
        cout<<"SORRY!!! YOUR SOLUTION IS INCORRECT!!!!!!!!!!! \n";
        else
        cout<<"CONGRATULATIONS!!!!! :) :) YOUR SOLUTION IS CORRECT!!\n\n\n";
return 0;
}
}
